﻿using Infragistics.Web.UI.DataSourceControls;
using Infragistics.Web.UI.GridControls;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        DataSet set = new DataSet();
        //Add two tables
        set.Tables.Add(BuildTable("Parent", 0, 100));
        set.Tables.Add(BuildChildTable("Child", 0, 100));

        //Create relations
        DataColumn parentColumn = set.Tables[0].Columns["id"];
        DataColumn childColumn = set.Tables[1].Columns["relation"];
        System.Data.DataRelation relation = new System.Data.DataRelation("RelationName", parentColumn, childColumn);
        set.Relations.Add(relation);

        WebHierarchicalDataGrid1.DataSource = set;
    }
    protected void WebHierarchicalDataGrid1_ContainerGridDataBinding(object sender, DataBindingEventArgs e)
    {
        ContainerGrid grid = (ContainerGrid)sender;
        int currentPage = 0;

        WebHierarchicalDataSource source = new WebHierarchicalDataSource();

        currentPage = grid.Behaviors.Paging.PageIndex;
        int pageSize = grid.Behaviors.Paging.PageSize;
        int startIndex = currentPage * pageSize;


        Infragistics.Web.UI.DataSourceControls.DataView view = new Infragistics.Web.UI.DataSourceControls.DataView();
        view.ID = "DefaultView1";
        source.DataViews.Add(view);

        source.DataViews[0].DataSource = BuildTable("Parent", startIndex, startIndex + pageSize);

        Infragistics.Web.UI.DataSourceControls.DataView view2 = new Infragistics.Web.UI.DataSourceControls.DataView();
        view2.ID = "DefaultView2";
        source.DataViews.Add(view2);

        source.DataViews[1].DataSource = BuildChildTable("Child", startIndex, startIndex + pageSize);

        Infragistics.Web.UI.DataSourceControls.DataRelation relation = new Infragistics.Web.UI.DataSourceControls.DataRelation();
        relation.ChildColumns = new string[] { "relation" };
        relation.ParentColumns = new string[] { "id" };

        relation.ParentDataViewID = "DefaultView1";
        relation.ChildDataViewID = "DefaultView2";

        e.Cancel = true;
        e.DataSource = source;
        e.SelectArguments.TotalRowCount = 100;
    }


    private DataTable BuildTable(string name, int start, int end)
    {

        System.Data.DataTable table = new DataTable(name);
        DataColumn column;
        DataRow row;

        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "id";
        column.ReadOnly = true;
        table.Columns.Add(column);

        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Item";
        column.AutoIncrement = false;
        column.Caption = "Item";
        column.ReadOnly = false;
        column.Unique = false;
        table.Columns.Add(column);

        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Data";
        column.AutoIncrement = false;
        column.Caption = "Data";
        column.ReadOnly = false;
        column.Unique = false;
        table.Columns.Add(column);

        DataColumn[] PrimaryKeyColumns = new DataColumn[1];
        PrimaryKeyColumns[0] = table.Columns["id"];
        table.PrimaryKey = PrimaryKeyColumns;

        for (int i = start; i <= end; i++)
        {
            row = table.NewRow();
            row["id"] = i;
            row["Item"] = "Item " + i;
            row["Data"] = "Data " + i;
            table.Rows.Add(row);
        }
        return table;

    }

    private DataTable BuildChildTable(string name, int start, int end)
    {
        System.Data.DataTable table = new DataTable(name);
        DataColumn column;
        DataRow row;

        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "id";
        column.ReadOnly = true;
        table.Columns.Add(column);

        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Item";
        column.AutoIncrement = false;
        column.Caption = "Item";
        column.ReadOnly = false;
        column.Unique = false;
        table.Columns.Add(column);

        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Data";
        column.AutoIncrement = false;
        column.Caption = "Data";
        column.ReadOnly = false;
        column.Unique = false;
        table.Columns.Add(column);


        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "relation";
        column.AutoIncrement = false;
        column.Caption = "relation";
        column.ReadOnly = false;
        column.Unique = false;
        table.Columns.Add(column);

        DataColumn[] PrimaryKeyColumns = new DataColumn[1];
        PrimaryKeyColumns[0] = table.Columns["id"];
        table.PrimaryKey = PrimaryKeyColumns;

        for (int i = start; i <= end; i++)
        {
            row = table.NewRow();
            row["id"] = i;
            row["Item"] = "Item " + i;
            row["Data"] = "Data " + i;

            if ((i < 10) && (i >= 0))
            {

                row["relation"] = 0;
            }
            else if ((i < 20) && (i >= 10))
            {
                row["relation"] = 1;
            }
            else if ((i < 30) && (i >= 20))
            {
                row["relation"] = 2;
            }
            else if ((i < 40) && (i >= 30))
            {
                row["relation"] = 3;
            }
            else if ((i < 50) && (i >= 40))
            {
            }
            table.Rows.Add(row);
        }
        return table;

    }


    protected void WebHierarchicalDataGrid1_InitializeRow(object sender, RowEventArgs e)
    {
        ContainerGridRecord rec = (ContainerGridRecord)e.Row;
        if (rec.Index < 3)
        {
            rec.IsEmptyParent = true;
        }
    }
    protected void WebHierarchicalDataGrid1_RowIslandsPopulating(object sender, ContainerRowCancelEventArgs e)
    {
        ContainerGrid grid = new ContainerGrid();
        if (e.Row.RowIslands.Count == 0)
        {
            e.Cancel = true;
            ContainerGrid rid = new ContainerGrid();
            e.Row.RowIslands.Add(grid);
            grid.DataMember = "DefaultView2";
        }
        grid = e.Row.RowIslands[0];
        grid.DataSource = BuildChildTable("Child", 0, 100);
    }
}